#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

#include "coords.h"
#include "db.h"
#include "stock.h"

typedef struct Flags { 
    unsigned int verbose : 4 ; 
} Flags ;

static void
usage ()
{
    cbanner ( "$Date: 2002/05/24 14:44:35 $", 
	      "[-v] **arguments**",
	      "Author", 
	      "Company/University", 
	      "email@domain" ) ;
    exit (1);
}

int
main (int argc, char **argv)
{
    int             c,
                    errflg = 0;
    Dbptr           db;
    char           *database;
    Flags	    flags ;
    Pf             *pf;

    memset ( &flags, 0, sizeof(flags)) ;
    elog_init ( argc, argv ) ; 

    if (pfread (Program_Name, &pf) != 0)
	die (0, "Can't read parameter file\n");

    while ((c = getopt (argc, argv, "vV")) != -1) {
	switch (c) {

	case 'v':
	    flags.verbose++ ;
	    break;

	case 'V':
	    usage() ;

	default:
	    errflg++;
	    break ;
	}
    }

    if (errflg)
	usage ();

    database = argv[optind++];
    if ( dbopen_table ( database, "r+", &db ) < 0) { 
	die ( 0, "Can't open database %s\n", database ) ; 
    }


    return 0;
}
