#include "Pkt.h"

int
stuffPkt_User (Packet * pkt, char *srcname, double *timep, char **packetp, int *nbytes, int *ppsz)
{
    char           *pp,
                   *cp;
    int             retcode = 0;
    int             ICHAN = 0;
    PktChannel     *achan;
    if (strcmp (pkt->parts.src_suffix, "weather") == 0) {
	achan = gettbl (pkt->channels, 0);
	RESIZE_BUFFER (char *, *packetp, *ppsz,
		       (10 + (PKT_NAMESIZE + 16) * pkt->nchannels));
	pp = cp = *packetp;
	HI2NC (cp, &pkt->version, 1);
	cp += 1;
	HI2NC (cp, &pkt->nchannels, 1);
	cp += 1;
	for (ICHAN = 0; ICHAN < pkt->nchannels; ICHAN++) {
	    achan = gettbl (pkt->channels, ICHAN);
	    if (achan == 0) {
		achan = newPktChannel ();
		pushtbl (pkt->channels, achan);
	    }
	    memcpy (cp, &achan->chan, PKT_NAMESIZE);
	    cp += PKT_NAMESIZE;
	    HD2NF (cp, &achan->samprate, 1);
	    cp += 4;
	    HD2NF (cp, &achan->calib, 1);
	    cp += 4;
	    HD2NF (cp, &achan->calper, 1);
	    cp += 4;
	    H2N4 (cp, achan->data, achan->nsamp);
	    cp += 4 * achan->nsamp;
	}
	*timep = achan->time;
	*nbytes = cp - pp;
	insist (*nbytes < (10 + (PKT_NAMESIZE + 16) * pkt->nchannels));
    } else {
	retcode = -1;
    }
    return retcode;
}

int
unstuffPkt_User (char *srcname, double time, char *packet, int nbytes, Packet * pkt)
{
    char           *pp,
                   *cp;
    int             retcode = 0;
    int             ICHAN = 0;
    PktChannel     *achan;

    if (strcmp (pkt->parts.src_suffix, "weather") == 0) {
	achan = gettbl (pkt->channels, 0);
	if (achan == 0) {
	    achan = newPktChannel ();
	    pushtbl (pkt->channels, achan);
	}
	pp = cp = packet;
	NC2HI (&pkt->version, cp, 1);
	cp += 1;
	NC2HI (&pkt->nchannels, cp, 1);
	cp += 1;
	if (pkt->nchannels > 12)
	    return -1;
	for (ICHAN = 0; ICHAN < pkt->nchannels; ICHAN++) {
	    achan = gettbl (pkt->channels, ICHAN);
	    if (achan == 0) {
		achan = newPktChannel ();
		pushtbl (pkt->channels, achan);
	    }
	    achan->time = time;
	    strncpy (achan->net, pkt->parts.src_net, PKT_NAMESIZE);
	    strncpy (achan->sta, pkt->parts.src_sta, PKT_NAMESIZE);
	    memcpy (&achan->chan, cp, PKT_NAMESIZE);
	    cp += PKT_NAMESIZE;
	    strncpy (achan->loc, pkt->parts.src_loc, PKT_NAMESIZE);
	    achan->nsamp = 1;
	    NF2HD (&achan->samprate, cp, 1);
	    cp += 4;
	    NF2HD (&achan->calib, cp, 1);
	    cp += 4;
	    NF2HD (&achan->calper, cp, 1);
	    cp += 4;
	    strncpy (achan->segtype, "V", 4);
	    RESIZE_BUFFER (int *, achan->data, achan->datasz, achan->nsamp + 1);
	    N2H4 (achan->data, cp, achan->nsamp);
	    cp += 4 * achan->nsamp;
	}
	if (nbytes < cp - pp) {
	    complain (0, "nbytes=%d < cp-pp=%d\n", nbytes, cp - pp);
	    retcode = -1;
	}
	retcode = Pkt_wf ;
    } else {
	retcode = -1;
    }
    return retcode;
}
