/* This is just a reimplementation of the ascii datatype, as an
 * example of how to extend the trace library with some new datatype.
 */

#include "tr.h"

#define xxHdrSz 120

int 
readxx ( char *input, int nbytes,  int first, int nsamp, float *dest )
{
    int i, retcode ; 
    short x ;

    if ( nbytes >= xxHdrSz + (nsamp+first) * sizeof(short)) {
	input += xxHdrSz ; 
	for ( i = 0 ; i<nsamp ; i++ ) { 
	    N2H2(&x, input+((i+first)*sizeof(short)), 1 ) ; 
	    dest[i] = x ;
	}
	retcode = 0 ; 
    } else { 
	retcode = -6 ; /* file too short */
    }
    return retcode ; 
}

int
hdrxx ( Wfdisc *wfdisc, void *data, int nsamp, char **outbuf, int *nbytes, int *bufsz )
{
    SIZE_BUFFER(char *, *outbuf, *bufsz, xxHdrSz+1) ; 
    memset ( *outbuf, ' ', 120 ) ; 
    sprintf ( *outbuf, "%-59s\n***  %10d samples ***", "# Standard Fixed Size Header", nsamp ) ; 
    *nbytes = xxHdrSz ; 
    return 0 ; 
}

#define OUTSIDE(X,LOWER,UPPER) ((X) <= LOWER || (X) >= UPPER)

int
writexx ( Wfdisc *wfdisc, Trsample *data, int nsamp, char **outbuf, int *nbytes, int *bufsz )
{
    int i, needed, bps, flags=0 ; 
    short	    x, fill ; 
    float           MISSING,
                    lower,
                    upper;
    Wftype * type ;

    type = trwftype ("xx") ;
    lower = type->lower;
    upper = type->upper;
    bps = type->bytesPerSamp;
    fill = type->fill;

    needed = bps * nsamp ; 
    SIZE_BUFFER(char *, *outbuf, *bufsz, needed ) ;

    MISSING = trwftype ("s4")->fill;

    for (i=0 ; i<nsamp ; i++ ) { 
	if (data[i] == MISSING) {
	    x = fill;
	    flags |= TR_GAPS;
	} else {
	    if (OUTSIDE (data[i], lower, upper)) {
		flags |= TR_CLIPPED;
		if ( data[i] <= lower ) { 
		    x = lower+1 ; 
		} else { 
		    x = upper-1 ; 
		}
	    } else {
		x = floor (data[i]);
		if (x != data[i]) {
		    flags |= TR_TRUNCATED;
		}
	    }
	}
	wfdisc->checksum += x ;
	H2N2(*outbuf+(i*bps), &x, 1 ) ; 
    }
    *nbytes = needed ;
    return flags ; 
}

int
trailerxx ( Wfdisc *wfdisc, void *data, int nsamp, char **outbuf, int *nbytes, int *bufsz )
{
    SIZE_BUFFER(char *, *outbuf, *bufsz, 120) ; 
    sprintf ( *outbuf, "%d samples checksum=%x (ignored)\n", nsamp, wfdisc->checksum ) ; 
    *nbytes = strlen(*outbuf) ; 
    return 0 ; 
}
