      program dbtest
c
c
c
      implicit none
#include "db.i"
c
      character*100 input_db, output_db
      character*6  sta
      character*8  chan, phase
      character*50 field_name, table_name
      character*100 expression
c
      real*8       olat, olon, odepth, deltim, slat, slon, selev
c
      real*8       otime, parrtime, sarrtime
c
      integer      iargc, i, itest
      integer      evid, orid,arid
      integer      ntables, nfields, nrecords
      integer	   keys1, keys2, nojoin
      integer      db(4), dbtmp(4)
c
      call elog_init(0,0)
      if ( iargc() .ne. 3 ) then
         write ( 0, * ) "Usage: dbevent input_db  evid output_db" 
         stop 
      endif

      call getarg ( 1, input_db  ) 
      write (*,*) "The input database is ", input_db 
      call getarg ( 2, expression  ) 
      read (expression, *) evid 
      write (*,*) "The event id is ", evid
      call getarg ( 3, output_db  ) 
      write (*,*) "The output database is ", output_db 
c
c open the database
c
      if ( dbopen ( input_db , "r", db)  .lt. 0 ) 
     *    call die (0, "Can't open database") 
c
c get event table
c
      call dblookup ( db, db, "", "event", "", "" ) 
      call dbquery ( db, dbRECORD_COUNT, nrecords ) 
      write(*,*) "Number of records in event table is ", nrecords
c
c get origin table
c
      call dblookup ( dbtmp, db, "", "origin", "", "" ) 
      call dbquery ( dbtmp, dbRECORD_COUNT, nrecords ) 
      write(*,*) "Number of records in origin table is ", nrecords
c 
c join tables
c
      call dbjoin ( db, db, dbtmp, 0, 0, 0, 0, "" )
      call dbquery ( db, dbRECORD_COUNT, nrecords ) 
      write(*,*) "Number of records in joined table is ", nrecords
c
c subset preferred origin
c
      call dbsubset ( db, db, 'prefor == orid', "")
      call dbquery ( db, dbRECORD_COUNT, nrecords ) 
      write(*,*) "Number of records in subsetted table is ", nrecords
      call dbquery ( dbtmp, dbPRIMARY_KEY, keys1 )  
      call dbsort ( db, db, keys1, 0, "sort_origin" )
c
c get assoc table
c
      call dblookup ( dbtmp, db, "", "assoc", "", "" ) 
      call dbquery ( dbtmp, dbRECORD_COUNT, nrecords ) 
      write(*,*) "Number of records in assoc table is ", nrecords
c 
c join tables
c
      call dbjoin ( db, db, dbtmp, 0, 0, 0, 0, "" )
      call dbquery ( db, dbRECORD_COUNT, nrecords ) 
      write(*,*) "Number of records in joined table is ", nrecords
c
c get arrival table
c
      call dblookup ( dbtmp, db, "", "arrival", "", "" ) 
      call dbquery ( dbtmp, dbRECORD_COUNT, nrecords ) 
      write(*,*) "Number of records in arrival table is ", nrecords
c 
c join tables
c
      call dbjoin ( db, db, dbtmp, 0, 0, 0, 0, "" )
      call dbquery ( db, dbRECORD_COUNT, nrecords ) 
      write(*,*) "Number of records in joined table is ", nrecords
c
c get site table
c
      call dblookup ( dbtmp, db, "", "site", "", "" ) 
      call dbquery ( dbtmp, dbRECORD_COUNT, nrecords ) 
      write(*,*) "Number of records in site table is ", nrecords
c 
c join tables
c
      call dbjoin ( db, db, dbtmp, 0, 0, 0, 0, "" )
      call dbquery ( db, dbRECORD_COUNT, nrecords ) 
      write(*,*) "Number of records in joined table is ", nrecords
c
c extract data
c
      write ( expression, * ) "evid ==", evid 
      call dbsubset ( dbtmp, db, expression , "evt")
      call dbquery ( dbtmp, dbRECORD_COUNT, nrecords ) 
      write(*,*) "Number of records in evt table is ", nrecords
      do i = 0, nrecords-1
         dbtmp(4) = i
         itest = dbgetv ( dbtmp, "",
     *                    "evid", evid,
     *                    "lat", olat,
     *                    "lon", olon,
     *                    "depth", odepth,
     *                    "time", otime,
     *                    "orid", orid,
     *                     0)
         write(*,*) evid,olat,olon,odepth,otime,orid
  	 end do

      do i = 0, nrecords-1
         dbtmp(4) = i
         itest = dbgetv ( dbtmp, "",
     *                    "evid", evid,
     *                    "arrival.time", parrtime,
     *                    "arrival.arid", arid,
     *                    "iphase", phase,
     *                    "deltim", deltim,
     *                     0)
         write(*,10) evid,parrtime,arid,phase,deltim
  	end do
10      format ( i8, f15.3, i8, a3, f6.3 ) 

      do i = 0, nrecords-1
         dbtmp(4) = i
         itest = dbgetv ( dbtmp, "",
     *                    "evid", evid,
     *                    "arrival.sta", sta,
     *                    "site.lat", slat,
     *                    "site.lon", slon,
     *                    "elev", selev, 
     *                     0)
         write(*,*) evid,sta,slat,slon,selev
  	 end do
c
c write out new database
c
      itest = dbunjoin (db, output_db , 1) 
      if (itest .ne. 0) 
     *  call die ( 0, "unjoin fails" )  

      stop
      end
