C
C  This program does nothing useful, but does exercise many of
C  the Datascope fortran calls.  Don't run it on a database
C  you care about.
C


	program ftest
	implicit none 
	integer db(4) 
#include "db.i"
	character *25 database, schema  
	real *8 start, end, h2e 
	integer i, ntables, nfields, nrecords, wfid
	character *20 field_name, table_name
	character *1024 remark
	integer result 
	integer      iargc

        call elog_init(0,0)
        if ( iargc() .ne. 1 ) then
           write ( 0, * ) "Usage: dbexample database" 
           stop 
        endif

	call getarg ( 1, database )  
	write (*,*) "The database is ", database

C open the database
	if ( dbopen ( database, "r+", db) .ne. 0) 
     *     call die ( 0, "Can't open database" ) 
	    
C print out a record from every table
	call dbquery ( db, dbSCHEMA_NAME, schema ) 
	call dbquery ( db, dbTABLE_COUNT, ntables ) 
	do i=0, ntables-1
	    db(2) = i  
	    call dbquery ( db, dbRECORD_COUNT, nrecords ) 
	    call dbquery ( db, dbTABLE_NAME, table_name )
	    call dbquery ( db, dbFIELD_COUNT, nfields ) 
	    write (*,100) table_name, nrecords, nfields 
100 	    format ( a, " has ", i5, " records of ", i2, " fields." ) 

	    if ( nrecords .GT. 0 ) then 
		db(4) = 0 
		call print_record ( db ) 
		endif
	    enddo 

C Add 2 records to the wfdisc table, then delete the last one.

	wfid = dbnextid ( db, "wfid" )  
	start = h2e ( 1993, 150, 12, 20, 15.5D0 )  
	end = start + 180.0  

	write (*,*) "Adding first record to wfdisc" 

	call dblookup ( db, db, "", "wfdisc", "", "" ) 
	db(4) = dbaddv ( db, "wfdisc", 
     *	    "sta", "station", 
     *	    "chan", "channel", 
     *	    "time", start, 
     *	    "endtime", end, 
     *	    "nsamp", 250, 
     *	    "samprate", 250.0D0, 
     *	    "wfid", dbnextid(db, "wfid"),
     *      "lddate", end, 
     *	    0 ) 
	if ( db(4) .lt. 0 ) call complain(0, "couldn't add record" ) 

	write (*,*) "Adding more fields to record #", db(4)

	result = dbputv ( db, "wfdisc", 
     *	    "calib", 1.5D0, 
     *	    "calper", 10.0D0, 
     *	    "segtype", "V", 
     *	    "datatype", "t4", 
     *	    "clip", "N", 
     *	    "dir", "wf", 
     *	    "dfile", "test.sac", 
     *	    "foff", 632, 
     *      "lddate", end, 
     *	    0 ) 
	if ( result .lt. 0 ) call complain(0, "couldn't add record" ) 

	call print_record ( db ) 

	if ( result .LT. 0 ) then
	    write (*, *) "dbputv returns ", result
	    call complain ( 0, "dbputv fails" ) 
	    endif


	write (*,*) "Adding second record to wfdisc"
	db(4) = dbaddv ( db, "wfdisc", 
     *	    "sta", "station", 
     *	    "chan", "chan2", 
     *	    "time", start, 
     *	    "endtime", end, 
     *	    "nsamp", 250, 
     *	    "samprate", 250.0D0, 
     *	    "calib", 1.5D0, 
     *	    "calper", 10.0D0, 
     *	    "segtype", "V", 
     *	    "datatype", "t4", 
     *	    "clip", "N", 
     *	    "dir", "wf", 
     *	    "dfile", "test.sac", 
     *	    "foff", 632, 
     *	    "wfid", dbnextid(db, "wfid"),
     *      "lddate", end, 
     *	    0 ) 
	if ( db(4) .lt. 0 ) call complain(0, "couldn't add record" ) 

	db(3) = dbALL 
	call print_record ( db ) 

	write ( *,* ) "Deleting record #", db(4)
	if ( dbdelete ( db ) .LT. 0 ) 
     *      call complain (0, "Couldn't delete record" )

	db(4) = db(4) - 1 

	write (*,*) "Adding a comment to record #", db(4)
	if ( dbadd_remark ( db, 
     *	    "This is an added comment for the new wfdisc record" ).LT.0)
     *		call complain ( 0, "Couldn't add remark" ) 
	if (  dbget_remark ( db, remark )  .LT. 0 ) 
     *      call complain ( 0, "Couldn't get remark back" ) 

	write (*,*) "The added remark was '", remark, "'."
	stop
	end


	subroutine print_record ( db ) 
	implicit none 
	integer db(4)
#include "db.i"
	character *20 field_name
	character *100 field_string
	character *30 atime
	integer j, nfields, field_type, field_integer, year, day, hour, min
	real*8 field_real, sec

	call dbquery ( db, dbFIELD_COUNT, nfields ) 
	do j=0, nfields-1
	    db(3) = j  
	    call dbquery ( db, dbFIELD_NAME, field_name) 
	    call dbquery ( db, dbFIELD_TYPE, field_type) 
	    if ( field_type .EQ. dbSTRING .OR. field_type .EQ. dbDATE ) then
		if ( dbgetv ( db, "", field_name, field_string, 0 ) .LT. 0 ) 
     *		    call complain ( 0, "dbgetv of string fails" ) 
		write ( *, * ) field_name, " is '", field_string, "'."
	    elseif ( field_type .EQ. dbREAL ) then
		if ( dbgetv ( db, "", field_name, field_real, 0 ) .LT. 0 ) 
     *		    call complain ( 0, "dbgetv of real fails" ) 
		write ( *, * ) field_name, " is '", field_real, "'."
	    elseif ( field_type .EQ. dbTIME ) then
		if ( dbgetv ( db, "", field_name, field_real, 0 ) .LT. 0 ) 
     *		    call complain ( 0, "dbgetv of time fails" ) 
		call strtime(atime, field_real)
		write ( *, 110 ) field_name, atime
110 		format ( a, " is '", a, "'" ) 
	    elseif ( field_type .EQ. dbINTEGER .OR. field_type .EQ. dbYEARDAY ) then
		if ( dbgetv ( db, "", field_name, field_integer, 0 ) .LT. 0 ) 
     *		    call complain ( 0, "dbgetv of integer fails" ) 
		write ( *, * ) field_name, " is '", field_integer, "'."
	    else 
		write (*, * ) "Unknown field type for ", field_name
	    endif
	    enddo 
	end
