
require "getopts.pl" ;
 
if ( ! &Getopts('s:v') || @ARGV != 2 ) { 
    die ( "Usage: $0 [-s sleep] [-v] database email\n" ) ; 
}

use Datascope ;

$database = shift ; 
$email = shift ; 
$sleep = $opt_s ? $opt_s : 60 ; 

@db = dbopen ( $database, "r" ) ;
@db = dblookup ( @db, 0, "origin", 0, 0 ) ; 

$n = dbquery ( @db, "dbRECORD_COUNT") ; 
print STDERR "starting with $n records\n" if $opt_v ; 

for (;;) {
    sleep ( $sleep ) ;
    $n2 = dbquery ( @db, "dbRECORD_COUNT") ; 
    if ( $n2 > $n ) { 
	send_email ( $n, $n2, $email, @db ) ; 
	$n = $n2 ; 
    }
}


sub send_email { 
    my ( $n, $n2, $email, @db ) = @_ ; 

    open ( EMAIL, "|mailx -s 'new origins' $email" ) ; 
    my ($lat, $lon, $depth, $time, $mb ) ;
    for ( $db[3] = $n ; $db[3] < $n2 ; $db[3]++ ) { 
	($lat, $lon, $depth, $time, $mb ) = 
		dbgetv ( @db, qw(lat lon depth time mb)) ; 
	printf EMAIL "%5.2f   %8.3f %8.3f %6.2f   %s %s\n", 
	    $mb, $lat, $lon, $depth, &strtime($time), &grname($lat, $lon) ; 
	printf STDERR "%5.2f   %8.3f %8.3f %6.2f   %s %s\n", 
	    $mb, $lat, $lon, $depth, &strtime($time), &grname($lat, $lon) 
	    	if $opt_v ; 
    }
    close EMAIL ;
}

