        program fpredict
        implicit none
#include "db.i"
	real*8 str2epoch
	integer iargc

        integer db(4)
        character*64 lat, lon, depth, time
        real *8  epoch 
        character*256 table
        integer  pf, pgm
        character*256 expr, staname
	character*64 stime
        integer i, result, n 
        real*8      pred 
        integer keys  

        call elog_init(0,0)
        call pfread("predict", pf, result ) 
        if ( result ) then
                call die ( "Can't read parameter file" )  
        endif

        if ( iargc() .ne. 4 ) then
                call die ( "Usage: fpredict lat lon depth time" ) 
        endif
        
        call getarg(1, lat)
        call getarg(2, lon)
        call getarg(3, depth)
        call getarg(4, time)

        epoch = str2epoch(time) 

        call pfget_string(pf, "table", table ) 

        if ( dbopen_table ( table, "r", db)  .LT. 0 )
     *     call die ( 0, "Can't open database" )

        write ( expr, "('distance(lat,lon,', a, ',', a, ')')") lat, lon   

        call strtbl(keys, expr, 0) 

        call dbsort ( db, db, keys, 0, "" )

        write ( expr, "('ptime(distance(lat,lon,', a, ',', a, '), ', a, 
     *              ')' )") lat, lon, depth
        result = dbex_compile ( db, expr, pgm, 0 )
        call dbquery ( db, dbRECORD_COUNT, n )

      do i = 0, n-1
         db(4) = i
         result = dbex_eval ( db, pgm, 0, pred ) 
         pred = pred + epoch  
         result = dbgetv ( db, "", "staname", staname, 0 )  
	 call strtime(stime, pred) 
         write (*, 110) staname, stime 
       end do

110     format ( a55, a ) 
	end
