
proc tkinspect_exit {} {
    destroy .
    exit 0
}

proc tkinspect_widgets_init {} {
    global tkinspect_library
    foreach file {
	lists.tcl procs_list.tcl globals_list.tcl windows_list.tcl
	images_list.tcl about.tcl value.tcl help.tcl cmdline.tcl
	windows_info.tcl menus_list.tcl canvas_list.tcl
    } {
	uplevel #0 source $tkinspect_library/$file
    }
}

proc tkinspect_about {} {
    catch {destroy .about}
    about .about
    .about run
}


proc tkinspect_create_main_window {args} {
    global tkinspect
    set w [eval tkinspect_main .main[incr tkinspect(counter)] $args]
    incr tkinspect(main_window_count)
    return $w
}


proc tkinspect_failure {reason} {
    global tkinspect
    set tkinspect(error_is_failure) 1
    error $reason
}

proc tkerror {message} {
    global tkinspect errorInfo
    if [info exists tkinspect(error_is_failure)] {
	unset tkinspect(error_is_failure)
	tk_dialog .failure "Tkinspect Failure" $message warning 0 Ok
    } else {
	uplevel [list tk_tkerror $message]
    }
}
